*+--------------------------------------------------------------------
*+
*+ Source Module => c:\hmg.3.4.4\0\EXCEL\\DBFEXCEL.PRG
*+
*+    Copyright(C) 1983-2013 by Auge & Ohr
*+
*+    Functions: Procedure MAIN()
*+               Procedure OpenDir()
*+               Static Procedure OpenXls()
*+               Static Procedure Array2GRID()
*+               Function GetDataType()
*+               Static Procedure WhatToDo()
*+               Static Procedure InitForm1()
*+               Static Procedure Form_1_Adjust()
*+               Procedure CloseForm1()
*+               Static Function ZAHL2CHR()
*+               Static Procedure SetEndRow()
*+               Static Procedure SetEndCol()
*+               Function TestType()
*+               Function VAR2CHAR()
*+               Static Function HeadColor()
*+               Static Procedure ShowRow()
*+               Static Procedure Pre_Form2()
*+
*+    Reformatted by Click! 2.05.24 on Jan-15-2020 at  3:02 am
*+
*+--------------------------------------------------------------------

#INCLUDE "HMG.CH"
#INCLUDE "COMMON.CH"

#define Use_Debug .T.

STATIC xVersion := "v0.17"

MEMVAR Button_Open
MEMVAR cLastDir

*+--------------------------------------------------------------------
*+
*+    Procedure MAIN()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE MAIN

/*********************************************************************
* v0.17  15.01.2020 Source Part2 Release
* v0.16  13.01.2020 re-position GetDataType() just before Save2Dbf()
* v0.15  11.01.2020 Split Demo2 : CompareTypeFormat()
* v0.14  10.01.2020 HeadColor() / no Background Color ?
* v0.13  10.01.2020 cGoesTo = "TESTTYPE"
* v0.12  10.01.2020 F9 "Data Type" / dbclick on Row User want as TYPE
* v0.11  10.01.2020 VAR2CHAR() with STRTRAN()
* v0.10  09.01.2020 Split -> DEMO2.PRG
* v0.09  08.01.2020 bad idea : erase o:NumberFormat when NIL
* v0.08  08.01.2020 CompareTypeFormat() / erase o:NumberFormat when NIL
* v0.07  07.01.2020 FindDataLine()
* v0.06  07.01.2020 FindMax() mit VAR2CHAR()
* v0.05  07.01.2020 Xls to DBF with nStart / nRowEnd
*
*********************************************************************/
PUBLIC Button_Open
PUBLIC cLastDir    := GetCurrentFolder()

   SET CENTURY ON
   SET DATE GERMAN
   SET EPOCH TO YEAR( DATE() ) - 50

   IF !IsWindowDefined( MainForm )
      Load Window MainForm

      ON KEY ESCAPE OF MainForm ACTION MainForm.Release
      CENTER WINDOW MainForm

      Activate Window MainForm
   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure OpenDir()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE OpenDir( cInitPath )

LOCAL cXls             := ""
LOCAL cTitle           := "open Excel XLS " + xVersion
LOCAL lNewFolderButton := .F.

   DEFAULT cInitPath TO cLastDir

   cXls := GetFile( { { "Excel Sheet", "*.xls*" } }, cTitle, TRIM( cInitPath ) )
   IF !EMPTY( cXls )
      cLastDir := SUBSTR( cXls, 1, RAT( "\", cXls ) )
      IF ".XLS" $ UPPER( cXls )
         OpenXls( cXls )
      ELSE
         MsgInfo( "wrong Data Type " + cXls )
      ENDIF
   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure OpenXls()
*+
*+    Called from ( dbfexcel.prg )   1 - procedure opendir()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE OpenXls( cXls )

LOCAL oExcel
LOCAL oWorkBook
LOCAL oSheet
LOCAL oRange
LOCAL oError
LOCAL bSaveError
LOCAL i, cType
LOCAL numRows
LOCAL numColumns
LOCAL cEnde
LOCAL Retvar     := .F.
LOCAL aExcel     := {}
LOCAL aWide      := {}
LOCAL aFormat    := {}
LOCAL aClone

   IF ( oExcel := win_oleCreateObject( "Excel.Application" ) ) == NIL
      MsgInfo( 'Error: Microsoft Excel is not installed, ', win_OleErrorText() )
      RETURN
   ENDIF

   MainForm.Button_Open.hide()

   // save Errorblock
   bSaveError := ERRORBLOCK()
   // set new Errorblock
   ERRORBLOCK( { | e | BREAK( e ) } )
   BEGIN SEQUENCE

      // remember using SET CENTURY ON / SET DATE xxx

      oExcel:Application:visible := .F.

      // disable warnings
      oExcel:Application:DisplayAlerts := .F.

      // open XLS-Table in Workbook
      oExcel:Application:workbooks:Open( cXls )

      // Make the first one active
      oWorkBook := oExcel:activeWorkBook
      oExcel:Application:Worksheets( 1 ) :activate()

      // Speed things up by creating an object containing the cells
      oSheet := oExcel:Worksheets( 1 ) :cells

      // count ROW and COL
      numRows := oWorkBook:workSheets( 1 ) :usedRange:Rows:Count
      numColumns := oWorkBook:workSheets( 1 ) :usedRange:Columns:Count

      // create Array with wanted Dimension
      i := 1
      FOR i := 1 TO numRows
         AADD( aExcel, ARRAY( numColumns ) )
      NEXT
      cEnde := ZAHL2CHR( numColumns )

      // fit all Column to optimal size
      // oSheet:EntireColumn:AutoFit()
      oSheet:Columns( "A:" + cEnde ) :autoFit()

      // transfer to Array
      aExcel := oSheet:range( "A1:" + cEnde + LTRIM( STR( numRows ) ) ) :value

      // get o:ColumnWidth and o:NumberFormat
      FOR i := 1 TO numColumns
         AADD( aWide, oSheet:Columns( i ) :ColumnWidth )
         AADD( aFormat, oSheet:Columns( i ) :NumberFormat )
      NEXT

      // close Excel
      oExcel:Quit()

      // we need to ACLONE() Array while it is only a Reference
      aClone := ACLONE( aExcel )
      // to "close" EXCEL
      oExcel := NIL

   RECOVER USING oError
      MsgInfo( "Error Excel ..." )
   END SEQUENCE
   // restore Errorblock
   ERRORBLOCK( bSaveError )

   // now show Array in GRID
   Array2GRID( aClone, cXls, aWide, aFormat )

   MainForm.Button_Open.show()

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure Array2GRID()
*+
*+    Called from ( dbfexcel.prg )   1 - static procedure openxls()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE Array2GRID( aExcel, cXls, aWide, aFormat )

LOCAL cDBF         := GetCurrentFolder() + "\Template.DBF"
LOCAL aType        := {}
LOCAL aData        := {}
LOCAL aHead        := {}
LOCAL aWidths      := {}
LOCAL aLine        := {}
LOCAL aNew         := {}
LOCAL aBackColor   := {}
LOCAL aForeColor   := {}
LOCAL aClickHead   := {}
LOCAL nRowHead     := 1
LOCAL nRowStart    := 2
LOCAL nTestRowType := 2
LOCAL nRowEnd      := 2
LOCAL nColEnd      := 1
LOCAL cWho         := ""
LOCAL cGoesTo      := "TESTTYPE"
LOCAL i, iMax
LOCAL j, jMax
LOCAL bBackColor
LOCAL bForeColor
LOCAL bClickHead
   // LOCAL aDir := DIRECTORY("*.*")         // use as Array Sample for GRID

   iMax := LEN( aExcel )
   FOR i := 1 TO iMax
      AADD( aHead, CHR( i + 64 ) )                                    // A-Z
      AADD( aWidths, aWide[ i ] * 10 )                                // twips ...
   NEXT
   nColEnd := iMax

   iMax := LEN( aExcel )                                              // Rows
   jMax := LEN( aExcel[ 1 ] )                                         // Columns
   j := 1
   FOR j := 1 TO jMax                                                 // every Column
      aLine := {}
      i := 1
      FOR i := 1 TO iMax                                              // build Line
         // check for NIL
         IF NIL = aExcel[ i ] [ j ]                                   // if NIL -> ""
            aExcel[ i ] [ j ] := ""
         ENDIF
         AADD( aLine, aExcel[ i ] [ j ] )                             // Line Array
      NEXT
      AADD( aNew, ACLONE( aLine ) )                                   // use ACLONE(aLine) !
   NEXT
   nRowEnd := LEN( aNew )

   // get VALTYPE() from nTestRowType
   GetDataType( @aData, @aType, aNew, nColEnd, nTestRowType )

   // Color Codeblock "Inside/OutofArea"
   bBackColor := { || IF( ( This.CellRowIndex < nRowStart .OR. This.CellRowIndex > nRowEnd .OR. This.CellColIndex > nColEnd ), ;
                   { 155, 0, 0 }, { 255, 255, 255 } ) }
   bForeColor := { || IF( ( This.CellRowIndex < nRowStart .OR. This.CellRowIndex > nRowEnd .OR. This.CellColIndex > nColEnd ), ;
                   { 255, 255, 255 }, { 0, 0, 0 } ) }

   // Color block Header
   bClickHead := { || SetEndCol( aNew, @nColEnd ) }

   jMax := LEN( aHead )
   j := 1
   FOR j := 1 TO jMax                                                 // every Column
      AADD( aBackColor, bBackColor )
      AADD( aForeColor, bForeColor )
      AADD( aClickHead, bClickHead )
   NEXT

   DEFINE WINDOW Form_1 ;
         AT 0, 0 ;
         WIDTH 1280 ;
         HEIGHT 1024 ;
         TITLE cXls ;
         ICON "d:\ALASKA\RES\OHR2.ICO" ;
         FONTNAME "Calibri" ;
         FONTSIZE 11 ;
         ON MAXIMIZE Form_1_Adjust( "Form_1" ) ;
         ON SIZE Form_1_Adjust( "Form_1" ) ;
         ON INIT InitForm1() ;
         ON RELEASE CloseForm1( cDBF )

      DEFINE TOOLBAR oTOOLBAR ;
            OF Form_1 ;
            RIGHTTEXT ;
            BUTTONSIZE 64, 32

         BUTTON oBtSave ;
                 CAPTION "F4: Save 2 DBF" ;
                 PICTURE "d:\ALASKA\RES\Save32.ico" ;
                 NOTRANSPARENT ;
                 TOOLTIP "next to save" ;
                 ACTION Pre_Form2( aNew, aHead, aWidths, cXls, @cDBF, aFormat, @nColEnd, @nRowHead, @nRowStart, @nRowEnd, aData, aType, nTestRowType, cGoesTo )

         BUTTON oBtHeaderRow ;
                 CAPTION "F5: Header Row" ;
                 NOTRANSPARENT ;
                 TOOLTIP "activate Header data Row" ;
                 ACTION WhatToDo( @cGoesTo, "HEADROW" )

         BUTTON oBtStartRow ;
                 CAPTION "F6: Start Data" ;
                 NOTRANSPARENT ;
                 TOOLTIP "activate start Row data" ;
                 ACTION WhatToDo( @cGoesTo, "STARTDATA" )

         BUTTON oBtEndeRow ;
                 CAPTION "F7: Ende Data" ;
                 NOTRANSPARENT ;
                 TOOLTIP "activate last Row data" ;
                 ACTION WhatToDo( @cGoesTo, "ENDEDATA" )

         BUTTON oBtEndeCol ;
                 CAPTION "F8: End Col" ;
                 NOTRANSPARENT ;
                 TOOLTIP "activate last Col data" ;
                 ACTION WhatToDo( @cGoesTo, "ENDCOL" )

         BUTTON oBtTestType ;
                 CAPTION "F9: Data Type" ;
                 NOTRANSPARENT ;
                 TOOLTIP "activate Row to test data type" ;
                 ACTION { || WhatToDo( @cGoesTo, "TESTTYPE" ) }

      END TOOLBAR

      @ 040, 170 TEXTBOX StartHead_1 ;
              OF Form_1 ;
              WIDTH 64 ;
              HEIGHT 30 ;
              FONT "Calibri" SIZE 11 ;
              NUMERIC ;
              VALUE nRowHead ;
              TOOLTIP "set Header data Row" ;
              ON CHANGE { || nRowHead := Form_1.StartHead_1.Value }

      @ 040, 302 TEXTBOX StartRow_1 ;
              OF Form_1 ;
              WIDTH 64 ;
              HEIGHT 30 ;
              FONT "Calibri" SIZE 11 ;
              NUMERIC ;
              VALUE nRowStart ;
              TOOLTIP "set start Row data" ;
              ON CHANGE { || nRowStart := Form_1.StartRow_1.Value }

      @ 040, 434 TEXTBOX EndeRow_1 ;
              OF Form_1 ;
              WIDTH 64 ;
              HEIGHT 30 ;
              FONT "Calibri" SIZE 11 ;
              NUMERIC ;
              VALUE nRowEnd ;
              TOOLTIP "set last Row data" ;
              ON CHANGE { || nRowEnd := Form_1.EndeRow_1.Value }

      @ 040, 566 TEXTBOX EndeCol_1 ;
              OF Form_1 ;
              WIDTH 64 ;
              HEIGHT 30 ;
              FONT "Calibri" SIZE 11 ;
              NUMERIC ;
              VALUE nColEnd ;
              TOOLTIP "set last Col data" ;
              ON CHANGE { || nColEnd := Form_1.EndeCol_1.Value }

      @ 040, 698 TEXTBOX TestType_1 ;
              OF Form_1 ;
              WIDTH 64 ;
              HEIGHT 30 ;
              FONT "Calibri" SIZE 11 ;
              NUMERIC ;
              VALUE nTestRowType ;
              TOOLTIP "Row to test data type" ;
              ON CHANGE { || nTestRowType := Form_1.TestType_1.Value }

      @ 080, 010 GRID Grid_1 ;
              OF Form_1 ;
              FONT "Calibri" ;
              SIZE 11 ;
              WIDTH 1240 ;
              HEIGHT 870 ;
              HEADERS aHead ;
              WIDTHS aWidths ;
              ITEMS aNew ;
              TOOLTIP "set End-Row with double-click" ;
              DYNAMICBACKCOLOR aBackColor ;
              DYNAMICFORECOLOR aForeColor ;
              ON DBLCLICK SetEndRow( aNew, cGoesTo ) ;
              ON HEADCLICK aClickHead ;
              ON CHANGE ShowRow( LEN( aNew ) )

      DEFINE STATUSBAR
         STATUSITEM STR( 1 ) + "/" + STR( LEN( aNew ) )
         WIDTH 500
         DATE
         CLOCK
      END STATUSBAR

   END WINDOW

   jMax := LEN( aHead )                                               // Columns
   IF LEN( aFormat ) >= jMax
      j := 1
      FOR j := 1 TO jMax                                              // every Column
         Form_1.Grid_1.Header( j ) := VAR2CHAR( aFormat[ j ] )
         HeadColor( VAR2CHAR( aFormat[ j ] ), j )
      NEXT
   ELSE
      MsgInfo( "Problem " + LTRIM( STR( jMax ) ) + ;
               " aFormat :" + LTRIM( STR( LEN( aFormat ) ) ) )
   ENDIF

   ON KEY F4 OF Form_1 ACTION Pre_Form2( aNew, aHead, aWidths, cXls, @cDBF, aFormat, @nColEnd, @nRowHead, @nRowStart, @nRowEnd, aData, aType, nTestRowType, cGoesTo )
   ON KEY F5 OF Form_1 ACTION WhatToDo( @cGoesTo, "HEADROW" )
   ON KEY F6 OF Form_1 ACTION WhatToDo( @cGoesTo, "STARTDATA" )
   ON KEY F7 OF Form_1 ACTION WhatToDo( @cGoesTo, "ENDEDATA" )
   ON KEY F8 OF Form_1 ACTION WhatToDo( @cGoesTo, "ENDCOL" )
   ON KEY F9 OF Form_1 ACTION { || WhatToDo( @cGoesTo, "TESTTYPE" ) }

   ON KEY ESCAPE OF Form_1 ACTION Form_1.Release

   Form_1.grid_1.setfocus()
   CENTER WINDOW Form_1
   ACTIVATE WINDOW Form_1

RETURN

*+--------------------------------------------------------------------
*+
*+    Function GetDataType()
*+
*+    Called from ( dbfexcel.prg )   1 - static procedure array2grid()
*+                                   1 - static procedure pre_form2()
*+
*+--------------------------------------------------------------------
*+
FUNCTION GetDataType( aData, aType, aNew, nColEnd, nTestRowType )

LOCAL nCol       := 1
LOCAL cText
LOCAL cType
LOCAL bSaveError

   aData := {}
   aType := {}

   bSaveError := ERRORBLOCK()
   // set new Errorblock
   ERRORBLOCK( { | e | BREAK( e ) } )
   BEGIN SEQUENCE
      FOR nCol := 1 TO nColEnd
         cText := aNew[ nTestRowType ] [ nCol ]
         AADD( aData, cText )
         cType := TestType( cText )
         AADD( aType, cType )
      NEXT
   RECOVER USING oError
      MsgInfo( "Error out of Area ..." )
   END SEQUENCE
   // restore Errorblock
   ERRORBLOCK( bSaveError )

RETURN NIL

*+--------------------------------------------------------------------
*+
*+    Static Procedure WhatToDo()
*+
*+    Called from ( dbfexcel.prg )  10 - static procedure array2grid()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE WhatToDo( cGoesTo, cWho )

   DO CASE
      CASE cWho = "HEADROW"
         Form_1.StartHead_1.SetFocus()
      CASE cWho = "STARTDATA"
         Form_1.StartRow_1.SetFocus()
      CASE cWho = "ENDEDATA"
         Form_1.EndeRow_1.SetFocus()
      CASE cWho = "ENDCOL"
         Form_1.EndeCol_1.SetFocus()
      CASE cWho = "TESTTYPE"
         Form_1.TestType_1.SetFocus()
      OTHERWISE

   ENDCASE
   // per Reference
   cGoesTo := cWho
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure InitForm1()
*+
*+    Called from ( dbfexcel.prg )   1 - static procedure array2grid()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE InitForm1()

   Form_1.grid_1.PaintDoubleBuffer := .T.
   Form_1.grid_1.EnableUpdate()
   Form_1.grid_1.Refresh()
   Form_1.grid_1.setfocus()
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure Form_1_Adjust()
*+
*+    Called from ( dbfexcel.prg )   2 - static procedure array2grid()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE Form_1_Adjust( cName )

LOCAL nWidth
LOCAL nHeight

   nWidth := GetProperty( cName, "Width" )
   nHeight := GetProperty( cName, "Height" )

   Setproperty( cName, "Grid_1", "Width", nWidth - 40 )
   Setproperty( cName, "Grid_1", "Height", nHeight - 90 - 40 - 24 )

RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure CloseForm1()
*+
*+    Called from ( dbfexcel.prg )   1 - static procedure array2grid()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE CloseForm1( cDBF )

   RELEASE KEY F4 OF Form_1
   RELEASE KEY F5 OF Form_1
   RELEASE KEY F6 OF Form_1
   RELEASE KEY F7 OF Form_1
   RELEASE KEY F8 OF Form_1
   RELEASE KEY F9 OF Form_1
   RELEASE KEY ESCAPE OF Form_1

   Form_1.Grid_1.DYNAMICBACKCOLOR := NIL
   Form_1.Grid_1.DYNAMICFORECOLOR := NIL

   IF FILE( cDBF )
      FERASE( cDBF )
   ENDIF

   MainForm.Button_Open.show()

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Function ZAHL2CHR()
*+
*+    Called from ( dbfexcel.prg )   1 - static procedure openxls()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION ZAHL2CHR( numColumns )

LOCAL nMal
LOCAL cEnde

   IF numColumns > 26
      nMal := INT( numColumns / 26 )
      cEnde := CHR( nMal + 64 ) + CHR( ( numColumns - ( nMal * 26 ) ) + 64 )
   ELSE
      cEnde := CHR( numColumns + 64 )
   ENDIF

RETURN cEnde

*+--------------------------------------------------------------------
*+
*+    Static Procedure SetEndRow()
*+
*+    Called from ( dbfexcel.prg )   1 - static procedure array2grid()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE SetEndRow( aNew, cGoesTo )

LOCAL nRow := This.CellRowIndex
LOCAL iMax := LEN( aNew )

   IF nRow <= iMax
      DO CASE
         CASE cGoesTo = "HEADROW"
            Form_1.StartHead_1.Value := nRow
         CASE cGoesTo = "STARTDATA"
            Form_1.StartRow_1.Value := nRow
         CASE cGoesTo = "ENDEDATA"
            Form_1.EndeRow_1.Value := nRow
         CASE cGoesTo = "TESTTYPE"
            Form_1.TestType_1.Value := nRow
         CASE cGoesTo = "ENDCOL"
            MsgInfo( "not support for Column" )
            RETURN
         OTHERWISE
            MsgInfo( "first press F5 - F7 for Selection" )
            RETURN
      ENDCASE
      MsgInfo( "set " + cGoesTo + " Row : " + LTRIM( STR( nRow ) ) + " of " + LTRIM( STR( iMax ) ) )
   ENDIF
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure SetEndCol()
*+
*+    Called from ( dbfexcel.prg )   1 - static procedure array2grid()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE SetEndCol( aNew, nInOut )

LOCAL nCol := This.CellColIndex                                       // BUG Col+1
LOCAL iMax := LEN( aNew[ 1 ] )

   IF nCol <= iMax
      nInOut := nCol
      MsgInfo( "End Col : " + ;
               LTRIM( STR( nCol ) ) + " of " + ;
               LTRIM( STR( iMax ) ) )
   ENDIF
RETURN

*+--------------------------------------------------------------------
*+
*+    Function TestType()
*+
*+    Called from ( dbfexcel.prg )   1 - function getdatatype()
*+
*+--------------------------------------------------------------------
*+
FUNCTION TestType( xValue )

LOCAL cRet       := " "
LOCAL bSaveError

   bSaveError := ERRORBLOCK()
   ERRORBLOCK( { | e | BREAK( e ) } )
   BEGIN SEQUENCE
      IF EMPTY( xValue )
         DO CASE
            CASE NIL = xValue
               xValue := ""
               cRet := "C"
            CASE VALTYPE( xValue ) = "D"
               cRet := 'D'
            CASE VALTYPE( xValue ) = "N"
               cRet := 'N'
            CASE VALTYPE( xValue ) = "L"
               cRet := 'L'

            CASE VALTYPE( xValue ) = "C"
               cRet := 'C'
               DO CASE
                  CASE LEN( xValue ) = 8 .AND. SUBSTR( xValue, 3, 1 ) = "." .AND. SUBSTR( xValue, 6, 1 ) = "."
                     cRet := 'D'
                  CASE LEN( xValue ) = 10 .AND. SUBSTR( xValue, 3, 1 ) = "." .AND. SUBSTR( xValue, 6, 1 ) = "."
                     cRet := 'D'
                  CASE LEN( xValue ) = 8 .AND. SUBSTR( xValue, 3, 1 ) = "/" .AND. SUBSTR( xValue, 6, 1 ) = "/"
                     cRet := 'D'
                  CASE LEN( xValue ) = 10 .AND. SUBSTR( xValue, 3, 1 ) = "/" .AND. SUBSTR( xValue, 6, 1 ) = "/"
                     cRet := 'D'
                  CASE VAL( xValue ) = 0
                     cRet := 'N'
               ENDCASE

            OTHERWISE
               cRet := "C"
         ENDCASE

      ELSE
         DO CASE
            CASE NIL = xValue
               xValue := ""
               cRet := "C"
            CASE VALTYPE( xValue ) = "D"
               cRet := 'D'
            CASE VALTYPE( xValue ) = "N"
               cRet := 'N'
            CASE VALTYPE( xValue ) = "L"
               cRet := 'L'
            CASE VALTYPE( xValue ) = "C"
               cRet := 'C'
               DO CASE
                  CASE LEN( xValue ) = 8 .AND. SUBSTR( xValue, 3, 1 ) = "." .AND. SUBSTR( xValue, 6, 1 ) = "."
                     cRet := 'D'
                  CASE LEN( xValue ) = 10 .AND. SUBSTR( xValue, 3, 1 ) = "." .AND. SUBSTR( xValue, 6, 1 ) = "."
                     cRet := 'D'
                  CASE LEN( xValue ) = 8 .AND. SUBSTR( xValue, 3, 1 ) = "/" .AND. SUBSTR( xValue, 6, 1 ) = "/"
                     cRet := 'D'
                  CASE LEN( xValue ) = 10 .AND. SUBSTR( xValue, 3, 1 ) = "/" .AND. SUBSTR( xValue, 6, 1 ) = "/"
                     cRet := 'D'
                  CASE UPPER( xValue ) = ".T."
                     cRet := 'L'
                  CASE UPPER( xValue ) = ".F."
                     cRet := 'L'
                  CASE UPPER( xValue ) = "TRUE"
                     cRet := 'L'
                  CASE UPPER( xValue ) = "FALSE"
                     cRet := 'L'
                  CASE VAL( xValue ) > 0
                     cRet := 'N'
               ENDCASE
            OTHERWISE
               cRet := "C"
         ENDCASE
      ENDIF
   RECOVER USING oError
      // restore Errorblock
      // ERRORBLOCK( bSaveError )
      cRet := "C"
   END SEQUENCE
   // restore Errorblock
   ERRORBLOCK( bSaveError )

RETURN cRet

*+--------------------------------------------------------------------
*+
*+    Function VAR2CHAR()
*+
*+    Called from ( dbfexcel.prg )   2 - static procedure array2grid()
*+                ( demo2.prg )   1 - procedure save2dbf()
*+                                   2 - static procedure savecreate()
*+                                   2 - static function convtype()
*+                                   1 - function findmax()
*+                                   3 - procedure comparetypeformat()
*+
*+--------------------------------------------------------------------
*+
FUNCTION VAR2CHAR( cIn )

LOCAL cOut := hb_valToExp( cIn )
RETURN STRTRAN( cOut, '"', '' )

*+--------------------------------------------------------------------
*+
*+    Static Function HeadColor()
*+
*+    Called from ( dbfexcel.prg )   1 - static procedure array2grid()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION HeadColor( cIn, nCol )

LOCAL nIndex
LOCAL aFColor    := { { 255, 000, 000 }, { 255, 255, 255 } }
LOCAL aBColor    := { { 000, 255, 000 }, { 000, 000, 000 } }
LOCAL nForecolor := _GRID_COLUMN_HEADERFORECOLOR_
LOCAL nBackcolor := _GRID_COLUMN_HEADERBACKCOLOR_

   IF "NIL" $ cIn
      Form_1.Grid_1.HeaderDYNAMICFORECOLOR( nCol ) := { || aFColor[ 1 ] }
      Form_1.Grid_1.HeaderDYNAMICBACKCOLOR( nCol ) := { || aFColor[ 2 ] }
   ELSE
      Form_1.Grid_1.HeaderDYNAMICFORECOLOR( nCol ) := { || aBColor[ 1 ] }
      Form_1.Grid_1.HeaderDYNAMICBACKCOLOR( nCol ) := { || aBColor[ 2 ] }
   ENDIF

RETURN NIL

*+--------------------------------------------------------------------
*+
*+    Static Procedure ShowRow()
*+
*+    Called from ( dbfexcel.prg )   1 - static procedure array2grid()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE ShowRow( iMax )

   // LOCAL cString := STR(This.CellRowIndex)+"/"+STR(iMax)
LOCAL cString := STR( This.CellRowFocused ) + "/" + STR( iMax )
   Form_1.StatusBar.Item( 1 ) := cString
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure Pre_Form2()
*+
*+    Called from ( dbfexcel.prg )   2 - static procedure array2grid()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE Pre_Form2( aNew, aHead, aWidths, cXls, cDBF, aFormat, nColEnd, nRowHead, nRowStart, nRowEnd, aData, aType, nTestRowType, cGoesTo )

   Form_1.hide()

   // get VALTYPE() from nTestRowType
   GetDataType( @aData, @aType, aNew, nColEnd, nTestRowType )

   // now show Structur to create DBF
   Save2Dbf( aNew, aHead, aWidths, cXls, @cDBF, aFormat, @nColEnd, @nRowHead, @nRowStart, @nRowEnd, aData, aType, nTestRowType, cGoesTo )

   Form_1.show()
   Form_1.StartHead_1.Value := nRowHead
   Form_1.StartRow_1.Value := nRowStart
   Form_1.EndeRow_1.Value := nRowEnd

RETURN

//
//
//

*+ EOF: DBFEXCEL.PRG
