*+--------------------------------------------------------------------
*+
*+ Source Module => c:\hmg.3.4.4\0\EXCEL\\DEMO2.PRG
*+
*+    Copyright(C) 1983-2013 by Auge & Ohr
*+
*+    Functions: Procedure Save2Dbf()
*+               Function LenOfDec()
*+               Procedure CloseForm2()
*+               Static Function CheckCaption()
*+               Static Procedure CheckOutDbf()
*+               Static Procedure SaveCreate()
*+               Static Function ConvType()
*+               Function FindMax()
*+               Static Function FindHeaderLine()
*+               Static Function FindDataLine()
*+               Static Function TestHeaderLine()
*+               Static Function Cre_Struct()
*+               Procedure CompareTypeFormat()
*+
*+       Tables: c:\hmg.3.4.4\0\EXCEL\\USE (cDBF) ALIAS "Template" EXCLUSIVE
*+               c:\hmg.3.4.4\0\EXCEL\\USE (cOutPutDBF) ALIAS OUTDBF EXCLUSIVE
*+
*+    Reformatted by Click! 2.05.24 on Jan-15-2020 at  3:02 am
*+
*+--------------------------------------------------------------------

#INCLUDE "HMG.CH"
#INCLUDE "COMMON.CH"

#define Use_Debug .T.

*+--------------------------------------------------------------------
*+
*+    Procedure Save2Dbf()
*+
*+    Called from ( dbfexcel.prg )   1 - static procedure pre_form2()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE Save2Dbf( aNew, aHead, aWidths, cXls, cDBF, aFormat, nColEnd, nRowHead, nRowStart, nRowEnd, aData, aType, nTestRowType, cGoesTo )

LOCAL nCol
LOCAL cHead, cType, nLen, nDec
LOCAL aWide      := { 160, 100, 100, 100 }
LOCAL aCaption   := { "Field", "Type", "Len", "Dec" }
LOCAL lDone      := .F.
LOCAL aHave      := {}
LOCAL nFoundHead := 0
LOCAL j, jMax := LEN( aHead )
LOCAL cOutPutDBF, clower
LOCAL cText
LOCAL xValue, cValue

   IF LEN( aWidths ) <> LEN( aHead )
      msginfo( "Error LEN(aWidths) <> LEN(aHead)" )
      RETURN
   ENDIF

   IF LEN( aType ) < LEN( aHead )
      msginfo( "Error LEN(aType) <> LEN(aHead)" + CRLF + "press F9 and DblClick on Data to detect Type" )
      RETURN
   ENDIF

   IF LEN( aData ) < LEN( aHead )
      msginfo( "Error LEN(aData) <> LEN(aHead)" )
      RETURN
   ENDIF

   clower := LOWER( cXls )
   DO CASE
      CASE ".xlsx" $ clower
         cOutPutDBF := STRTRAN( clower, ".xlsx", ".dbf" )
      CASE ".xls" $ clower
         cOutPutDBF := STRTRAN( clower, ".xls", ".dbf" )
   ENDCASE

   FOR j := 1 TO jMax
      IF EMPTY( aHead[ j ] )                                          // can be NIL
         aHead[ j ] := ""
      ENDIF
   NEXT

   nFoundHead := FindHeaderLine( aNew, @aHead, nRowHead, nColEnd )
   IF nFoundHead > nRowHead
      nRowHead := nFoundHead
   ENDIF

   IF nFoundHead > nRowStart
      nRowStart := nFoundHead + 1
   ENDIF

   nFoundData := FindDataLine( aNew, nRowStart, nColEnd )
   IF nFoundData > nRowStart
      nRowStart := nFoundData
   ENDIF

   SELECT 1
   IF !FILE( cDBF )
      Cre_Struct( cDBF )                                              // CREATE template
   ENDIF
   USE (cDBF) ALIAS "Template" EXCLUSIVE
   ZAP

   nCol := 1
   FOR nCol := 1 TO nColEnd
      // need check if only A-Z and 0-9 ist used.
      // do NOT start with Number as ALIAS will fail
      cHead := CheckCaption( aHead[ nCol ], aHave )
      cType := aType[ nCol ]
      nLen := 0
      nDec := 0
      xValue := aData[ nCol ]

      // User have press F9 and select Row
      //
      IF cGoesTo = "TESTTYPE"
         DO CASE
            CASE cType = "L"
               nLen := 1
            CASE cType = "D"
               nLen := 10
            CASE cType = "N"
               cValue := UPPER( VAR2CHAR( xValue ) )
               nLen := LEN( cValue )
               IF "," $ cValue                                        // German Version
                  nDec := LenOfDec( cValue, "," )
               ELSEIF "." $ cValue                                    // hm ...
                  nDec := LenOfDec( cValue, "." )
               ENDIF
            CASE cType = "C"
               nLen := FindMax( aNew, nRowStart, nRowEnd, nCol )
         ENDCASE
      ELSE
         // pass per Reference @
         CompareTypeFormat( @cType, @nLen, @nDec, aFormat[ nCol ], aData[ nCol ], aNew, nRowStart, nRowEnd, nCol )
      ENDIF

      APPEND BLANK
      REPLACE Template->FIELD_NAME WITH cHead
      REPLACE Template->FIELD_TYPE WITH cType
      REPLACE Template->FIELD_LEN WITH nLen
      REPLACE Template->FIELD_DEC WITH nDec
      COMMIT
   NEXT

   SET BROWSESYNC ON
   GO TOP

   DEFINE WINDOW Form_2 ;
         AT 0, 0 ;
         WIDTH 500 ;
         HEIGHT 650 ;
         TITLE cXls ;
         ICON "d:\ALASKA\RES\OHR2.ICO" ;
         FONTNAME "Calibri" ;
         FONTSIZE 11 ;
         ON RELEASE CloseForm2( cDBF, lDone )

      DEFINE TOOLBAR oTOOLBAR ;
            OF Form_2 ;
            RIGHTTEXT ;
            BUTTONSIZE 64, 32

         BUTTON oBtSave ;
                 CAPTION "F5: create DBF" ;
                 PICTURE "d:\ALASKA\RES\SQL.ico" ;
                 ACTION SaveCreate( cOutPutDBF, aNew, aHead, nRowStart, nRowEnd, nColEnd, @lDone, aType )

      END TOOLBAR

      @ 050, 010 TEXTBOX OutPutDBF ;
              OF Form_2 ;
              WIDTH 460 ;
              HEIGHT 30 ;
              FONT "Calibri" SIZE 11 ;
              VALUE cOutPutDBF ;
              ON CHANGE CheckOutDbf( cOutPutDBF )

      @ 090, 10 LABEL LabelStartRow ;
              OF Form_2 ;
              WIDTH 60 ;
              HEIGHT 30 ;
              FONT "Calibri" SIZE 11 ;
              VALUE "Start ROW"

      @ 090, 100 TEXTBOX StartRowPoint ;
              OF Form_2 ;
              WIDTH 60 ;
              HEIGHT 30 ;
              FONT "Calibri" SIZE 11 ;
              NUMERIC ;
              VALUE nRowStart ;
              ON CHANGE { || nRowStart := Form_2.StartRowPoint.Value }

      @ 090, 230 LABEL LabelEndeRow ;
              OF Form_2 ;
              WIDTH 60 ;
              HEIGHT 30 ;
              FONT "Calibri" SIZE 11 ;
              VALUE "last ROW"

      @ 090, 300 TEXTBOX EndeRowPoint ;
              OF Form_2 ;
              WIDTH 60 ;
              HEIGHT 30 ;
              FONT "Calibri" SIZE 11 ;
              NUMERIC ;
              VALUE nRowEnd ;
              ON CHANGE { || nRowEnd := Form_2.EndeRowPoint.Value }

      @ 130, 10 BROWSE Brow_2 ;
              OF Form_2 ;
              WIDTH 460 ;
              HEIGHT 470 ;
              HEADERS aCaption ;
              WIDTHS aWide ;
              WORKAREA template ;
              FIELDS { "template->FIELD_NAME", "template->FIELD_TYPE", "template->FIELD_LEN", "template->FIELD_DEC" } ;
              FONT "Calibri" SIZE 22

   END WINDOW

   ON KEY F5 OF Form_2 ACTION SaveCreate( cOutPutDBF, aNew, aHead, nRowStart, nRowEnd, nColEnd, @lDone, aType )
   ON KEY ESCAPE OF Form_2 ACTION Form_2.Release

   CheckOutDbf( cOutPutDBF )

   // Setproperty( "Form_2", "Brow_2", "ALLWEDIT", .T.)               // does not work
   _SetBrowseAllowEdit( "Brow_2", "Form_2", .T. )                     // this work

   Form_2.Brow_2.setfocus
   CENTER WINDOW Form_2
   ACTIVATE WINDOW Form_2

RETURN

*+--------------------------------------------------------------------
*+
*+    Function LenOfDec()
*+
*+    Called from ( demo2.prg )   2 - procedure save2dbf()
*+
*+--------------------------------------------------------------------
*+
FUNCTION LenOfDec( cString, cSign )

LOCAL nRet  := 0
LOCAL nLen  := LEN( cString )
LOCAL nPosi

   nPosi := AT( cSign, cString )
   nRet := nLen - nPosi

RETURN nRet

*+--------------------------------------------------------------------
*+
*+    Procedure CloseForm2()
*+
*+    Called from ( demo2.prg )   1 - procedure save2dbf()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE CloseForm2( cDBF, lDone )

   RELEASE KEY F5 OF Form_2
   RELEASE KEY ESCAPE OF Form_2
   SELECT 1
   IF USED()
      CLOSE
   ENDIF
   IF lDone = .T.
      // IF FILE(cDBF)
      //    FERASE(cDBF)
      // ENDIF
   ENDIF
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Function CheckCaption()
*+
*+    Called from ( demo2.prg )   1 - procedure save2dbf()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION CheckCaption( xHead, aHave )

LOCAL cRet  := ""
LOCAL i, iMax
LOCAL cSign
LOCAL cOK   := "ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890_"

   IF EMPTY( xHead )
   ELSE
      IF VALTYPE( xHead ) <> "C"
         RETURN cRet
      ENDIF

      xHead := TRIM( xHead )
      iMax := LEN( xHead )
      FOR i := 1 TO iMax
         cSign := UPPER( SUBSTR( xHead, i, 1 ) )
         IF cSign $ cOK
            cRet += cSign
         ENDIF
      NEXT
      cRet := TRIM( SUBSTR( cRet + SPACE( 10 ), 1, 10 ) )
      IF EMPTY( cRet )
         MSGInfo( "FIELD Name need !" )
         cRet := xHead
      ELSE
         IF ASCAN( aHave, { | e | e = cRet } ) > 0
            MSGInfo( "FIELD " + cRet + " already used" )
            cRet := xHead
         ELSE
            AADD( aHave, cRet )
         ENDIF
      ENDIF
   ENDIF
RETURN cRet

*+--------------------------------------------------------------------
*+
*+    Static Procedure CheckOutDbf()
*+
*+    Called from ( demo2.prg )   2 - procedure save2dbf()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE CheckOutDbf( cOutPutDBF )

   IF FILE( cOutPutDBF )
      Setproperty( "Form_2", "OutPutDBF", "FontColor", { 255, 255, 255 } )
      Setproperty( "Form_2", "OutPutDBF", "BackColor", { 255, 0, 0 } )
   ELSE
      Setproperty( "Form_2", "OutPutDBF", "FontColor", { 0, 0, 0 } )
      Setproperty( "Form_2", "OutPutDBF", "BackColor", { 255, 255, 255 } )
   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure SaveCreate()
*+
*+    Called from ( demo2.prg )   2 - procedure save2dbf()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE SaveCreate( cOutPutDBF, aNew, aHead, nRowStart, nRowEnd, nColEnd, lDone, aType )

LOCAL cHead, cType, nLen, nDec
LOCAL aStruc     := {}
LOCAL i, j, nCol
LOCAL OldSel     := SELECT ()
LOCAL bSaveError, oError
LOCAL cError     := ""
LOCAL nTimeStart, nTimeEnd, xValue
LOCAL lRunOnce   := .F.

   IF FILE( cOutPutDBF )
      IF MsgYesNo( "DBF exist, override ",, .T. )
         FERASE( cOutPutDBF )
      ELSE
         RETURN
      ENDIF
   ENDIF

   SELECT 1
   GO TOP
   FOR nCol := 1 TO nColEnd
      cHead := Template->FIELD_NAME
      cType := Template->FIELD_TYPE
      nLen := Template->FIELD_LEN
      nDec := Template->FIELD_DEC
      AADD( aStruc, { cHead, cType, nLen, nDec } )

      aType[ nCol ] := cType
      SKIP
      IF EOF()
         EXIT
      ENDIF
   NEXT

   SELECT 2
   DBCREATE( cOutPutDBF, aStruc )
   USE (cOutPutDBF) ALIAS OUTDBF EXCLUSIVE

   nTimeStart := SECONDS()
   FOR i := nRowStart TO nRowEnd
      bSaveError := ERRORBLOCK()
      // set new Errorblock
      ERRORBLOCK( { | e | BREAK( e ) } )
      BEGIN SEQUENCE
         APPEND BLANK

         j := 1
         FOR j := 1 TO nColEnd
            cHead := aStruc[ j ] [ 1 ]
            cType := aStruc[ j ] [ 2 ]
            xValue := aNew[ i ] [ j ]
            IF VALTYPE( xValue ) = cType
               FIELDPUT( j, xValue )
            ELSE
               xValue := ConvType( xValue, cType )
               IF VALTYPE( xValue ) = cType
                  FIELDPUT( j, xValue )
               ELSE
                  cError += "Error 1 " + VAR2CHAR( xValue ) + " Row " + LTRIM( STR( i ) ) + " Col " + LTRIM( STR( j ) ) + " " + VALTYPE( xValue ) + " <> " + cType + CRLF
               ENDIF
            ENDIF
         NEXT
      RECOVER USING oError
         COMMIT
         IF lRunOnce = .F.
            lRunOnce := .T.
            cError += "ERROR: " + oError:description + ;
                    IIF( EMPTY( oError:operation ), "", ;
                    HB_OSNEWLINE() + oError:operation ) + ;
                    HB_OSNEWLINE()

            cError += oError:subsystem + "/" + ALLTRIM( STR( oError:subcode ) ) + ;
                    " (generic code " + ALLTRIM( STR( oError:genCode ) ) + ;
                    ", os code " + ALLTRIM( STR( oError:osCode ) ) + ")" + ;
                    HB_OSNEWLINE()
         ENDIF

         cError += "Error Value " + VAR2CHAR( xValue ) + ;
                                              HB_OSNEWLINE() + ;
                                              "Row " + LTRIM( STR( i ) ) + " Col " + LTRIM( STR( j ) ) + ;
                                              HB_OSNEWLINE()

      END SEQUENCE
      ERRORBLOCK( bSaveError )                                        // restore Errorblock

      IF lRunOnce = .T.
         EXIT
      ENDIF
   NEXT
   SELECT 2
   COMMIT
   CLOSE

   nTimeEnd := SECONDS() - nTimeStart

   IF !EMPTY( cError )
      MsgInfo( cError )
   ELSE
      lDone := .T.
   ENDIF

   IF lDone = .T.
      MsgInfo( "Data transfer to " + cOutPutDBF + " ready " + LTRIM( STR( nTimeEnd ) ) + " Sec." )
   ENDIF
   // SELECT(OldSel)

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Function ConvType()
*+
*+    Called from ( demo2.prg )   1 - static procedure savecreate()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION ConvType( xValue, cMustType )

LOCAL cThisType
LOCAL xNewValue  := ""
LOCAL bSaveError

   bSaveError := ERRORBLOCK()                                         // save Errorblock
   ERRORBLOCK( { | e | BREAK( e ) } )                                 // set new Errorblock
   BEGIN SEQUENCE

      IF NIL = xValue
         cThisType := cMustType
      ENDIF

      cThisType := VALTYPE( xValue )

      DO CASE
         CASE cThisType = "C" .AND. cMustType = "C"
            IF EMPTY( xValue )
               xNewValue := ""
            ELSE
               xNewValue := xValue
            ENDIF
         CASE cThisType = "N" .AND. cMustType = "N"
            IF EMPTY( xValue )
               xNewValue := 0
            ELSE
               xNewValue := xValue
            ENDIF
         CASE cThisType = "D" .AND. cMustType = "D"
            IF EMPTY( xValue )
               xNewValue := CTOD( "  .  .  " )
            ELSE
               xNewValue := xValue
            ENDIF
         CASE cThisType = "L" .AND. cMustType = "L"
            IF EMPTY( xValue )                                        // S_OK
               xNewValue := .T.
            ELSE
               xNewValue := xValue
            ENDIF

            // ----------- cThisType = "C" -----------*

         CASE cThisType = "C" .AND. cMustType = "D"
            DO CASE
               CASE xValue = "  .  .  "
                  xNewValue := CTOD( xValue )
               CASE xValue = "  /  /  "
                  xNewValue := CTOD( xValue )
               CASE VAL( xValue ) > 0
                  xNewValue := STOD( xValue )
            ENDCASE

         CASE cThisType = "C" .AND. cMustType = "N"
            IF EMPTY( xValue )
               xNewValue := 0
            ELSE
               xNewValue := VAL( xValue )
            ENDIF

         CASE cThisType = "C" .AND. cMustType = "L"
            DO CASE
               CASE EMPTY( xValue )                                   // S_OK
                  xNewValue := .T.
               CASE xValue = "TRUE"
                  xNewValue := .T.
               CASE xValue = "FALSE"
                  xNewValue := .F.
               CASE xValue = ".T."
                  xNewValue := .T.
               CASE xValue = ".F."
                  xNewValue := .F.
            ENDCASE

            // ----------- cThisType = "N" -----------*

         CASE cThisType = "N" .AND. cMustType = "C"
            xNewValue := STR( xValue )

         CASE cThisType = "N" .AND. cMustType = "L"
            IF EMPTY( xValue )                                        // S_OK
               xNewValue := .T.
            ELSE
               xNewValue := .F.                                       // S_FALSE
            ENDIF

         CASE cThisType = "N" .AND. cMustType = "D"
            IF EMPTY( xValue )
               xNewValue := CTOD( "  .  .  " )
            ELSE
               xNewValue := STOD( LTRIM( STR( xValue ) ) )
            ENDIF

            // ----------- cThisType = "D" -----------*

         CASE cThisType = "D" .AND. cMustType = "C"
            xNewValue := DTOC( xValue )

         CASE cThisType = "D" .AND. cMustType = "N"
            xNewValue := VAL( DTOS( xValue ) )

         OTHERWISE
            msgInfo( "Error cThisType : " + VAR2CHAR( cThisType ) + " cMustType : " + VAR2CHAR( cMustType ) )
      ENDCASE

   RECOVER

   END SEQUENCE
   ERRORBLOCK( bSaveError )                                           // restore Errorblock

RETURN xNewValue

*+--------------------------------------------------------------------
*+
*+    Function FindMax()
*+
*+    Called from ( demo2.prg )   1 - procedure save2dbf()
*+
*+--------------------------------------------------------------------
*+
FUNCTION FindMax( aNew, nRowStart, nRowEnd, nCol )

LOCAL aSeek      := ACLONE( aNew )                                    // use ACLONE() !
LOCAL nMax, nLen := 0
LOCAL bSaveError, i

   bSaveError := ERRORBLOCK()                                         // save Errorblock
   ERRORBLOCK( { | e | BREAK( e ) } )                                 // set new Errorblock
   BEGIN SEQUENCE

      // reduce to 1-Dim
      //
      AEVAL( aSeek, { | a, i | aSeek[ i ] := aSeek[ i ] [ nCol ] }, nRowStart )

      // delete Row before nRowStart
      //
      FOR i := 1 TO nRowStart - 1
         ADEL( aSeek, 1 )
         ASIZE( aSeek, LEN( aSeek ) - 1 )
      NEXT

      // be sure to have String
      //
      AEVAL( aSeek, { | a, i | aSeek[ i ] := ALLTRIM( VAR2CHAR( aSeek[ i ] ) ) } )

      // just sort to find Max
      //
      ASORT( aSeek,, ( nRowEnd - nRowStart + 1 ), { | c1, c2 | LEN( c1 ) > LEN( c2 ) } )
   RECOVER

   END SEQUENCE
   ERRORBLOCK( bSaveError )                                           // restore Errorblock

   // it is 1st Element
   //
   nLen := LEN( TRIM( aSeek[ 1 ] ) )
   aSeek := NIL

RETURN nLen

*+--------------------------------------------------------------------
*+
*+    Static Function FindHeaderLine()
*+
*+    Called from ( demo2.prg )   1 - procedure save2dbf()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION FindHeaderLine( aNew, aHead, nRowHead, nColEnd )

LOCAL i
LOCAL j, jMax := LEN( aHead )
LOCAL cText := ""
LOCAL nRet  := 0

   // check
   FOR j := 1 TO jMax
      IF EMPTY( aHead[ j ] )                                          // might be NIL
         aHead[ j ] := ""
      ENDIF
   NEXT

   jMax := LEN( aNew )
   FOR j := nRowHead TO jMax
      i := 1
      cText := ""
      FOR i := 1 TO nColEnd
         cText += TestHeaderLine( aNew[ j ] [ i ] )                   // retun "Y" or "N"
         IF "N" $ cText
            EXIT
         ENDIF
      NEXT
      IF "N" $ cText
      ELSE
         nRet := j
         i := 1
         FOR i := 1 TO nColEnd
            aHead[ i ] := aNew[ j ] [ i ]
         NEXT
         EXIT
      ENDIF
   NEXT

RETURN nRet

*+--------------------------------------------------------------------
*+
*+    Static Function FindDataLine()
*+
*+    Called from ( demo2.prg )   1 - procedure save2dbf()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION FindDataLine( aNew, nRowStart, nColEnd )

LOCAL i
LOCAL j, jMax := LEN( aNew )
LOCAL xValue
LOCAL nRet   := 0
LOCAL lOK
LOCAL cText  := ""

   FOR j := nRowStart TO jMax
      i := 1
      lOK := .T.
      cText := ""
      FOR i := 1 TO nColEnd
         xValue := aNew[ j ] [ i ]
         DO CASE
            CASE VALTYPE( xValue ) = "C"
               IF EMPTY( xValue )
                  cText += "E"
               ENDIF
            CASE VALTYPE( xValue ) = "D"
            CASE VALTYPE( xValue ) = "N"
            CASE VALTYPE( xValue ) = "L"
            OTHERWISE
               lOK := .F.
               EXIT
         ENDCASE
      NEXT
      IF !EMPTY( cText ) .AND. LEN( cText ) = nColEnd
         lOK := .F.
      ENDIF
      IF lOK = .T.
         nRet := j
         EXIT
      ENDIF
   NEXT

RETURN nRet

*+--------------------------------------------------------------------
*+
*+    Static Function TestHeaderLine()
*+
*+    Called from ( demo2.prg )   1 - static function findheaderline()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION TestHeaderLine( xValue )

LOCAL lRet := "N"
   DO CASE
      CASE EMPTY( xValue )
      CASE VALTYPE( xValue ) = "C"                                    // assume Header all have Type "C"
         lRet := "Y"
      OTHERWISE
         lRet := "N"
   ENDCASE
RETURN lRet

*+--------------------------------------------------------------------
*+
*+    Static Function Cre_Struct()
*+
*+    Called from ( demo2.prg )   1 - procedure save2dbf()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION Cre_Struct( cDBF )

LOCAL aStructure := {}

   AADD( aStructure, { "FIELD_NAME", "C", 10, 0 } )
   AADD( aStructure, { "FIELD_TYPE", "C", 1, 0 } )
   AADD( aStructure, { "FIELD_LEN", "N", 3, 0 } )
   AADD( aStructure, { "FIELD_DEC", "N", 3, 0 } )

   DBCREATE( cDBF, aStructure )

RETURN aStructure

*+--------------------------------------------------------------------
*+
*+    Procedure CompareTypeFormat()
*+
*+    Called from ( demo2.prg )   1 - procedure save2dbf()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE CompareTypeFormat( cType, nLen, nDec, cFormat, xValue, aNew, nRowStart, nRowEnd, nCol )

LOCAL lMore  := .T.
LOCAL ccType := cFormat
LOCAL cValue := UPPER( VAR2CHAR( xValue ) )

   IF lMore = .T.
      MsgInfo( "missing Check " + CRLF + ;
               "Column :" + STR( nCol ) + CRLF + ;
               "Value  :" + cValue + CRLF + ;
               "Format :" + VAR2CHAR( ccType ) + CRLF + ;
               "detect :" + VAR2CHAR( cType ) )
   ENDIF

RETURN

//
//
//

*+ EOF: DEMO2.PRG